<?php

namespace Id4me\RP;

use GuzzleHttp\Client;
use Id4me\RP\Exception\InvalidAuthorityIssuerException;
use Id4me\RP\Exception\InvalidIDTokenException;
use Id4me\RP\Model\OpenIdConfig;

/**
 * Class responsible of handling entire Authorization Process toward OpenId Authority
 */
class Authorization
{
    /**
     * @var \GuzzleHttp\Client;
     */
    private $httpClient;

    /**
     * @var \Id4me\RP\Validation;
     */
    private $validation;

    /**
     * Discovery constructor.
     */
    public function __construct()
    {
        $this->httpClient = new Client();
        $this->validation = new Validation();
    }

    /**
     * Creates an authorization url out of given parameters
     *
     * @param string $authorizationEndpoint authority authorization endpoint to fetch url from
     * @param string $clientId clientId registered by authority
     * @param string $identifier identifier of consumer request open id data (might be a domain or user name)
     * @param string $redirectUrl url of relying part requesting to be redirected to after successful user authentication
     * @param string $state parameter containing data to be used by stateful mechanisms within relying part after http redirection
     *
     * @return string
     */
    public function getAuthorizationUrl(
        string $authorizationEndpoint,
        string $clientId,
        string $identifier,
        string $redirectUrl,
        string $state = null
    ) {
        $query = [
            'client_id'     => $clientId,
            'login_hint'    => $identifier,
            'redirect_uri'  => $redirectUrl,
            'scope'         => 'openid',
            'prompt'        => 'login',
            'response_type' => 'code'
        ];

        if (! empty($state)) {
            $query['state'] = $state;
        }

        return sprintf(
            '%s?%s',
            $authorizationEndpoint,
            http_build_query($query, null, '&', PHP_QUERY_RFC3986)
        );
    }

    /**
     * Retrieves access token data fetched from authority
     *
     * @param OpenIdConfig $openIdConfig OpenId Config Instance containing data fetched from authority
     * @param string $code value of one time token generated by authority
     * @param string $redirectUrl url of relying part requesting to be redirected to after successful user authentication
     * @param string $clientId clientId registered by authority
     * @param string $clientSecret clientSecret registered by authority
     *
     * @return array
     *
     * @throws InvalidAuthorityIssuerException if iss and issuer values are not equal
     * @throws InvalidIDTokenException if provided id token value does not pass any of 13 validation steps
     *         described in ID Token Validation specifications of ID4Me Documentation
     */
    public function getAccessTokens(
        OpenIdConfig $openIdConfig,
        string $code,
        string $redirectUrl,
        string $clientId,
        string $clientSecret
    ) {
        $result = null;

        $issuer        = $openIdConfig->getIssuer();
        $tokenEndpoint = $openIdConfig->getTokenEndpoint();
        $jwksUri       = $openIdConfig->getJwksUri();

        $publicKey = $this->httpClient->get($jwksUri);
        $response  = $this->httpClient->post($tokenEndpoint, [
            'auth'    => [$clientId, $clientSecret],
            'headers' => ['content-type' => 'application/x-www-form-urlencoded'],
            'body'    => http_build_query([
                'code'         => $code,
                'grant_type'   => 'authorization_code',
                'redirect_uri' => $redirectUrl
            ])
        ]);

        if ($response) {
            $accessTokens = json_decode($response->getBody()->getContents(), true);
            if (! isset($accessTokens['id_token'])) {
                throw new InvalidIDTokenException('ID Token not found');
            }

            $this->validation->validateIDToken(
                $issuer,
                $clientId,
                $accessTokens['id_token'],
                $publicKey->getBody()->getContents()
            );

            $result = $accessTokens;
        }

        return $result;
    }

    /**
     * Set current http client to another value
     *
     * @param Client $httpClient
     */
    public function setHttpClient(Client $httpClient)
    {
        $this->httpClient = $httpClient;
    }

    /**
     * Set current validation handler to another value
     *
     * @param Validation $validation
     */
    public function setValidation(Validation $validation)
    {
        $this->validation = $validation;
    }
}
